#!/bin/sh

echo "#############################################"
echo "#                                           #"
echo "# Upgrade EMaEval V1.493 vers V1.5 (Bonita5)#"
echo "#                                           #"
echo "#############################################"
echo ""
echo ""

echo " ! SAUVEGARDE VOS BASES DE DONNEE EMAEVAL ! "
echo ""

# Source the init script configuration
if [ -f "config.properties" ]; then
	. ./config.properties
else
     echo "#!/bin/sh" > config.properties
     chmod 777 config.properties
fi

if [ ! -d "BACKUP-EMA" ]; then 
   mkdir BACKUP-EMA
fi


if [ -z "$TOMCAT_PATH" ]; then
   echo "Entrez le chemin du répertoire du serveur TOMCAT :"
   read TOMCAT_PATH
   if [ -d $TOMCAT_PATH ]; then
   	echo "export TOMCAT_PATH="$TOMCAT_PATH >> config.properties
   else
        echo "Le répertoire indiqué n'existe pas !"
	exit
   fi
fi

if [ ! -d $TOMCAT_PATH/webapps/EvalComp ]; then

	echo "EMaEval ne semble pas etre installé sur ce serveur TOMCAT : " $TOMCAT_PATH
	rm config.properties
	echo "-> ECHEC"
	exit

fi

if [ -r $TOMCAT_PATH/webapps/EvalComp/META-INF/MANIFEST.MF ]; then
        echo "Verification de la version d'EMaEval ..."
	versionOK=`grep -qi "Implementation-Version: V1.493" $TOMCAT_PATH/webapps/EvalComp/META-INF/MANIFEST.MF` 
	echo "$versionOK"
	if [ "$versionOK" != 0 ]; then
		
		echo "Version EMAEval -> OK"
	else
		echo "La version d'EmaEval est incorrecte : V1.493 requise -> ECHEC"
		rm config.properties
	fi
else
	echo "Le numero de version d'EMaEval ne peut etre déterminé"
	echo "La version requise est V1.493 et superieure."
	echo "-> ECHEC"
	rm config.properties
	exit
fi

if [ "$versionOK" != 0 ]; then 

	if [ ! -f BACKUP-EMA/applicationContext-manager.xml  ]; then
		upgradeOK="1"
		echo ""
		echo "Entrez 'U' pour installer l'UPGRADE."
	fi
	echo ""

	if [ -f BACKUP-EMA/applicationContext-manager.xml  ]; then
		revertOK="1"
		echo ""
		echo "Entrez 'R' pour revenir à la version précédente."
	fi
	echo ""

	read COMMAND
	
	if [ "$upgradeOK" == "1" ];then
		if [ "$COMMAND" == "U"  ]; then	

		echo "- BACKUP : Déplacement des fichiers originaux dans le réperoitre BACKUP-EMA ..."
		mv $TOMCAT_PATH/webapps/EvalComp/WEB-INF/applicationContext-manager.xml BACKUP-EMA/	
		mv $TOMCAT_PATH/webapps/EvalComp/WEB-INF/lib/bonita* BACKUP-EMA
		mv $TOMCAT_PATH/webapps/EvalComp/WEB-INF/lib/c3p0* BACKUP-EMA
                mv $TOMCAT_PATH/webapps/EvalComp/WEB-INF/workflows/*.bpar BACKUP-EMA

		echo "- BACKUP : FAIT"

		echo "- COPIE : Copie des nouveaux fichiers pour Bonita 5 ..."

		cp applicationContext-manager.xml $TOMCAT_PATH/webapps/EvalComp/WEB-INF/
		tar xzf libs.tar.gz -C $TOMCAT_PATH/webapps/EvalComp/WEB-INF/lib/
		tar xzf bonita-properties.tar.gz -C $TOMCAT_PATH/

		chown -R root:root $TOMCAT_PATH/bonita-properties

		tar xzf workflows.tar.gz -C $TOMCAT_PATH/webapps/EvalComp/WEB-INF/workflows/
			
		echo "- COPIE : FAIT"

		echo "**"
		echo ""	
		echo "-> IMPORTANT : VOUS DEVEZ AJOUTER LA VARIABLE D'ENVIRONNEMENT '-DBONITA_HOME="$TOMCAT_PATH/bonita-properties"' DANS VOTRE 'CATALINA_OPTS' !!!!!!!"
		echo ""
		echo "UPGRADE s'est terminé CORRECTEMENT."
		fi
	elif [ "$revertOK" == "1" ];then
		if [ "$COMMAND" == "R"  ]; then
		
		echo "-> SUPPRESSION : Suppression des fichiers Bonita5 ..."
		
		for filename in `tar tzf libs.tar.gz`
			do
				rm $TOMCAT_PATH/webapps/EvalComp/WEB-INF/lib/$filename
			done
		
		rm -f $TOMCAT_PATH/webapps/EvalComp/WEB-INF/workflows/*.bar
		rm -f $TOMCAT_PATH/webapps/EvalComp/WEB-INF/applicationContext-manager.xml
		rm -rf $TOMCAT_PATH/bonita-properties
 		
		echo "-> SUPPRESSION : FAIT"
	

		echo "-> DEPLACLEMENT : Deplacement des fichiers originaux à leur emplacement d'origine ..."
		
		mv BACKUP-EMA/applicationContext-manager.xml $TOMCAT_PATH/webapps/EvalComp/WEB-INF/
		mv BACKUP-EMA/*.bpar $TOMCAT_PATH/webapps/EvalComp/WEB-INF/workflows/
		mv BACKUP-EMA/*.jar $TOMCAT_PATH/webapps/EvalComp/WEB-INF/lib/

		echo "-> DEPLACEMENT : FAIT"
		echo ""
		echo "REVERT s'est terminé CORRECTEMENT."
		fi
	else
		echo "-> ABANDON"
	fi
fi
